0
0 комментариев

Обновился с Debian 7 Wheezy до Debian 8 Jessie.
Версия default python 3.4.2, обновил django до 1.8.3.
При выполнении

django-admin startproject mysite

выдает ошибку

Traceback (most recent call last):   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 449, in
_build_master
    ws.require(__requires__)   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 745, in require
    needed = self.resolve(parse_requirements(requirements))   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 644, in resolve
    raise VersionConflict(dist, req) pkg_resources.VersionConflict: (Django 1.8.3 (/usr/local/lib/python3.4/dist-packages), Requirement.parse('Django==1.9.dev20150717115701')) During handling of the above exception, another exception occurred: Traceback (most recent call last):   File "/usr/local/bin/django-admin", line 5, in <module>
    from pkg_resources import load_entry_point   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 2876, in <module>
    working_set = WorkingSet._build_master()   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 451, in
_build_master
    return cls._build_from_requirements(__requires__)   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 464, in
_build_from_requirements
    dists = ws.resolve(reqs, Environment())   File "/usr/lib/python3/dist-packages/pkg_resources.py", line 639, in resolve
    raise DistributionNotFound(req) pkg_resources.DistributionNotFound: Django==1.9.dev20150717115701

Update

Появились вот такие ошибки:

Traceback (most recent call last):
  File "/usr/bin/apt-listchanges", line 29, in <module>
    import anydbm
ImportError: No module named 'anydbm'
Настраивается пакет apt-listchanges (2.85.13+nmu1) …
  File "/usr/sbin/update-python-modules", line 52
    print x
          ^
SyntaxError: Missing parentheses in call to 'print'
dpkg: ошибка при обработке пакета apt-listchanges (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
Настраивается пакет apt-xapian-index (0.47) …
Traceback (most recent call last):
  File "/usr/bin/pycompile", line 35, in <module>
    from debpython.version import SUPPORTED, debsorted, vrepr, \
  File "/usr/share/python/debpython/version.py", line 24, in <module>
    from ConfigParser import SafeConfigParser
ImportError: No module named 'ConfigParser'
dpkg: ошибка при обработке пакета apt-xapian-index (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
Настраивается пакет python-django (1.7.7-1) …
Traceback (most recent call last):
  File "/usr/bin/pycompile", line 35, in <module>
    from debpython.version import SUPPORTED, debsorted, vrepr, \
  File "/usr/share/python/debpython/version.py", line 24, in <module>
    from ConfigParser import SafeConfigParser
ImportError: No module named 'ConfigParser'
dpkg: ошибка при обработке пакета python-django (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
dpkg: зависимости пакетов не позволяют настроить пакет django-testproject:
 django-testproject зависит от python-django, однако:
  Пакет python-django пока не настроен.
 
dpkg: ошибка при обработке пакета django-testproject (--configure):
 проблемы зависимостей — оставляем не настроенным
dpkg: ошибка при обработке пакета python-six (--configure):
 пакет абсолютно неработоспособен; перед настройкой его
 следует переустановить
dpkg: ошибка при обработке пакета python-pkg-resources (--configure):
 пакет абсолютно неработоспособен; перед настройкой его
 следует переустановить
dpkg: зависимости пакетов не позволяют настроить пакет python-cryptography:
 python-cryptography зависит от python-six, однако:
  Пакет python-six пока не настроен.
 python-cryptography зависит от python-pkg-resources, однако:
  Пакет python-pkg-resources пока не настроен.
dpkg: ошибка при обработке пакета python-cryptography (--configure):
 проблемы зависимостей — оставляем не настроенным
Настраивается пакет python-egenix-mxtools (3.2.8-1) …
Traceback (most recent call last):
  File "/usr/bin/pycompile", line 35, in <module>
    from debpython.version import SUPPORTED, debsorted, vrepr, \
  File "/usr/share/python/debpython/version.py", line 24, in <module>
    from ConfigParser import SafeConfigParser
ImportError: No module named 'ConfigParser'
dpkg: ошибка при обработке пакета python-egenix-mxtools (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
dpkg: зависимости пакетов не позволяют настроить пакет python-egenix-mxdatetime:
 python-egenix-mxdatetime зависит от python-egenix-mxtools, однако:
  Пакет python-egenix-mxtools пока не настроен.
 
dpkg: ошибка при обработке пакета python-egenix-mxdatetime (--configure):
 проблемы зависимостей — оставляем не настроенным
dpkg: зависимости пакетов не позволяют настроить пакет python-openssl:
 python-openssl зависит от python-cryptography, однако:
  Пакет python-cryptography пока не настроен.
 python-openssl зависит от python-six, однако:
  Пакет python-six пока не настроен.
 
dpkg: ошибка при обработке пакета python-openssl (--configure):
 проблемы зависимостей — оставляем не настроенным
dpkg: зависимости пакетов не позволяют настроить пакет python-ndg-httpsclient:
 python-ndg-httpsclient зависит от python-openssl, однако:
  Пакет python-openssl пока не настроен.
 
dpkg: ошибка при обработке пакета python-ndg-httpsclient (--configure):
 проблемы зависимостей — оставляем не настроенным
dpkg: зависимости пакетов не позволяют настроить пакет python-setuptools:
 python-setuptools зависит от python-pkg-resources (= 5.5.1-1), однако:
  Пакет python-pkg-resources пока не настроен.
 
dpkg: ошибка при обработке пакета python-setuptools (--configure):
 проблемы зависимостей — оставляем не настроенным
dpkg: зависимости пакетов не позволяют настроить пакет python-pip:
 python-pip зависит от python-pkg-resources, однако:
  Пакет python-pkg-resources пока не настроен.
 python-pip зависит от python-setuptools (>= 0.6c1), однако:
  Пакет python-setuptools пока не настроен.
 python-pip зависит от python-six, однако:
  Пакет python-six пока не настроен.
 
dpkg: ошибка при обработке пакета python-pip (--configure):
 проблемы зависимостей — оставляем не настроенным
Настраивается пакет python-psycopg2 (2.5.4+dfsg-1) …
Traceback (most recent call last):
  File "/usr/bin/pycompile", line 35, in <module>
    from debpython.version import SUPPORTED, debsorted, vrepr, \
  File "/usr/share/python/debpython/version.py", line 24, in <module>
    from ConfigParser import SafeConfigParser
ImportError: No module named 'ConfigParser'
dpkg: ошибка при обработке пакета python-psycopg2 (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
Настраивается пакет python-software-properties (0.92.25debian1) …
Traceback (most recent call last):
  File "/usr/bin/pycompile", line 35, in <module>
    from debpython.version import SUPPORTED, debsorted, vrepr, \
  File "/usr/share/python/debpython/version.py", line 24, in <module>
    from ConfigParser import SafeConfigParser
ImportError: No module named 'ConfigParser'
dpkg: ошибка при обработке пакета python-software-properties (--configure):
 подпроцесс установлен сценарий post-installation возвратил код ошибки 1
При обработке следующих пакетов произошли ошибки:
 apt-listchanges
 apt-xapian-index
 python-django
 django-testproject
 python-six
 python-pkg-resources
 python-cryptography
 python-egenix-mxtools
 python-egenix-mxdatetime
 python-openssl
 python-ndg-httpsclient
 python-setuptools
 python-pip
 python-psycopg2
 python-software-properties

Update 2
Вот сейчас начал то же самое на чистом дебиане 8, установил джанго 1.7.7, установил-настроил постгрес, создал джанговский проект, пытаюсь это все дело залить в бд через python3 manage.py syncdb — т.е. уже дефолтная версия питона 2.7, а 3.4.2 вызываю явно через python3.
В settings.py изменил вот это:

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'myprojectdb',
        'USER': 'myprojectuser',
        'PASSWORD': '123',
        'HOST': '127.0.0.1',
        'PORT': '5432',
    }
}

При попытке установки psycopg2:

pip3  install psycopg2
Downloading/unpacking psycopg2
  Downloading psycopg2-2.6.1.tar.gz (371kB): 371kB downloaded
  Running setup.py (path:/tmp/pip-build-ui2ldts8/psycopg2/setup.py) egg_info for package psycopg2
 
Installing collected packages: psycopg2
  Running setup.py install for psycopg2
    Skipping implicit fixer: buffer
    Skipping implicit fixer: idioms
    Skipping implicit fixer: set_literal
    Skipping implicit fixer: ws_comma
    building 'psycopg2._psycopg' extension
    i586-linux-gnu-gcc -pthread -DNDEBUG -g -fwrapv -O2 -Wall -Wstrict-prototypes -g -fstack-protector-strong -Wformat -Werror=format-security -D_FORTIFY_SOURCE=2 -fPIC -DPSYCOPG_$
    In file included from psycopg/psycopgmodule.c:27:0:
    ./psycopg/psycopg.h:30:20: fatal error: Python.h: Нет такого файла или каталога
     #include <Python.h>
                        ^
    compilation terminated.
    error: command 'i586-linux-gnu-gcc' failed with exit status 1
    Complete output from command /usr/bin/python3 -c "import setuptools, tokenize;__file__='/tmp/pip-build-ui2ldts8/psycopg2/setup.py';exec(compile(getattr(tokenize, 'open', open)$
    running install
 
running build
 
running build_py
 
creating build
 
creating build/lib.linux-i686-3.4
 
creating build/lib.linux-i686-3.4/psycopg2
 
copying lib/pool.py -> build/lib.linux-i686-3.4/psycopg2
 
copying lib/tz.py -> build/lib.linux-i686-3.4/psycopg2
 
...
copying tests/test_transaction.py -> build/lib.linux-i686-3.4/psycopg2/tests
 
copying tests/test_cursor.py -> build/lib.linux-i686-3.4/psycopg2/tests
 
copying tests/test_module.py -> build/lib.linux-i686-3.4/psycopg2/tests
 
Skipping implicit fixer: buffer
 
Skipping implicit fixer: idioms
 
Skipping implicit fixer: set_literal
 
Skipping implicit fixer: ws_comma
 
running build_ext
 
building 'psycopg2._psycopg' extension
 
creating build/temp.linux-i686-3.4
 
creating build/temp.linux-i686-3.4/psycopg
 
i586-linux-gnu-gcc -pthread -DNDEBUG -g -fwrapv -O2 -Wall -Wstrict-prototypes -g -fstack-protector-strong -Wformat -Werror=format-security -D_FORTIFY_SOURCE=2 -fPIC -DPSYCOPG_DEFA$
 
In file included from psycopg/psycopgmodule.c:27:0:
 
./psycopg/psycopg.h:30:20: fatal error: Python.h: Нет такого файла или каталога
 
 #include <Python.h>
 
                    ^
 
compilation terminated.
 
error: command 'i586-linux-gnu-gcc' failed with exit status 1
----------------------------------------
Cleaning up...
Command /usr/bin/python3 -c "import setuptools, tokenize;__file__='/tmp/pip-build-ui2ldts8/psycopg2/setup.py';exec(compile(getattr(tokenize, 'open', open)(__file__).read().replace$

И еще возник вопрос — как же использовать тогда правильно виртуальное окружение для python 3.4.2? Раньше я пользовался virtualenv, но теперь, если я правильно понял, виртуальное окружение встроено в питон.

При попытке установки psycopg2 через pip:

...
creating build/temp.linux-i686-2.7/psycopg
 
i586-linux-gnu-gcc -pthread -DNDEBUG -g -fwrapv -O2 -Wall -Wstrict-prototypes -fno-strict-aliasing -D_FORTIFY_SOURCE=2 -g -fstack-protector-strong -Wformat -Werror=format-security$
 
In file included from psycopg/psycopgmodule.c:27:0:
 
./psycopg/psycopg.h:30:20: fatal error: Python.h: Нет такого файла или каталога
 
 #include <Python.h>
 
                    ^
 
compilation terminated.
 
error: command 'i586-linux-gnu-gcc' failed with exit status 1
 
----------------------------------------
Cleaning up...
Command /usr/bin/python -c "import setuptools, tokenize;__file__='/tmp/pip-build-_np1vt/psycopg2/setup.py';exec(compile(getattr(tokenize, 'open', open)(__file__).read().replace('\$
Traceback (most recent call last):
  File "/usr/bin/pip", line 9, in <module>
    load_entry_point('pip==1.5.6', 'console_scripts', 'pip')()
  File "/usr/lib/python2.7/dist-packages/pip/__init__.py", line 248, in main
    return command.main(cmd_args)
  File "/usr/lib/python2.7/dist-packages/pip/basecommand.py", line 161, in main
    text = '\n'.join(complete_log)
UnicodeDecodeError: 'ascii' codec can't decode byte 0xd0 in position 54: ordinal not in range(128)

Update 3
Погуглил насчет Python.h, говорят, нужно установить python-dev.

При попытке sudo apt-get install python-dev
выдается ошибка:

Чтение списков пакетов… Готово
Построение дерева зависимостей
Чтение информации о состоянии… Готово
Некоторые пакеты невозможно установить. Возможно, вы просите невозможного,
или же используете нестабильную версию дистрибутива, где запрошенные вами
пакеты ещё не созданы или были удалены из Incoming.
Следующая информация, возможно, поможет вам:
 
Пакеты, имеющие неудовлетворённые зависимости:
 python-dev : Зависит: libpython-dev (= 2.7.9-1) но он не будет установлен
              Зависит: python2.7-dev (>= 2.7.9-1~) но он не будет установлен
E: Невозможно исправить ошибки, у вас отложены (held) битые пакеты.

sudo apt-get -f install не помогает, выдает все по нулям, очередная попытка установки — та же ошибка.

Далее:
Установил virtualenvwrapper, создал виртуальное окружение с python 3.4.2, в виртуальном окружении на этапе pip install psycopg2 тоже ругается на Python.h

Update:
Установил-таки python3-psycopg2 через aptitude. Но в виртуальном окружении при выполнении syncdb те же ошибки, не видит psycopg2


Добавить комментарий